// (C) Copyright 1999 by Autodesk, Inc. 
//
// Permission to use, copy, modify, and distribute this software in
// object code form for any purpose and without fee is hereby granted, 
// provided that the above copyright notice appears in all copies and 
// that both that copyright notice and the limited warranty and
// restricted rights notice below appear in all supporting 
// documentation.
//
// AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
// AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
// DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
// UNINTERRUPTED OR ERROR FREE.
//
// Use, duplication, or disclosure by the U.S. Government is subject to 
// restrictions set forth in FAR 52.227-19 (Commercial Computer
// Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
// (Rights in Technical Data and Computer Software), as applicable.
//
// Created by: Jorge Lopez
//             ObjectDBX Development
//             ADF / Engineering
//             Autodesk, Inc.

#ifndef _AXDOCKBAR_H
#define _AXDOCKBAR_H

#include "accont.h"

// Automation support for CAcUiContainerBar
class CAxContainerBar : public IAcadDockableContainer
{
    ULONG               m_refCount;
    CAcUiContainerBar*  m_containerBar;

    CAxContainerBar();  // do not allow default constructor to be called

public:
    
    CAxContainerBar(CAcUiContainerBar* pContainerBar) : m_refCount(0L)
    {
        ASSERT(pContainerBar != NULL);
        m_containerBar = pContainerBar;
    }

    STDMETHODIMP QueryInterface(REFIID, LPVOID*);
    STDMETHODIMP_(ULONG) AddRef(void);
    STDMETHODIMP_(ULONG) Release(void);

    STDMETHODIMP GetTypeInfoCount(UINT*);
    STDMETHODIMP GetTypeInfo(UINT, LCID, ITypeInfo**);
    STDMETHODIMP GetIDsOfNames(REFIID, OLECHAR**, UINT, LCID, DISPID*);
    STDMETHODIMP Invoke(DISPID, REFIID, LCID, WORD, DISPPARAMS*, VARIANT*, EXCEPINFO*, UINT*);

    STDMETHODIMP Float(void);
    STDMETHODIMP Dock(void);
    STDMETHODIMP put_Caption(BSTR newVal);
    STDMETHODIMP get_Caption(BSTR* pVal);
    STDMETHODIMP put_AllowDocking(VARIANT_BOOL newVal);
    STDMETHODIMP get_AllowDocking(VARIANT_BOOL* pVal);
    STDMETHODIMP get_IsFloating(VARIANT_BOOL* pVal);
    STDMETHODIMP put_EnableDockPositions(long newVal);
    STDMETHODIMP get_EnableDockPositions(long* pVal);
    STDMETHODIMP SetPreferredDockPosition(long DockPosition, VARIANT FloatingRect);
};

#endif // _AXDOCKBAR_H
